# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/FootstepDataRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import ihmc_msgs.msg

class FootstepDataRosMessage(genpy.Message):
  _md5sum = "c1fbe47501162f4d3ae6a243380c56d7"
  _type = "ihmc_msgs/FootstepDataRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## FootstepDataRosMessage
# This message specifies the position, orientation and side (left or right) of a desired footstep in
# world frame.

# Specifies whether the given location is the location of the ankle or the sole.
uint8 origin

# Specifies which foot will swing to reach the foostep.
uint8 robot_side

# Specifies the position of the footstep. It is expressed in world frame.
geometry_msgs/Vector3 location

# Specifies the orientation of the footstep. It is expressed in world frame.
geometry_msgs/Quaternion orientation

# predictedContactPoints specifies the vertices of the expected contact polygon between the foot and
# the world. A value of null or an empty list will default to using the entire foot. Contact points 
# are expressed in sole frame. This ordering does not matter. For example: to tell the controller to
# use the entire foot, the predicted contact points would be: predicted_contact_points: - {x: 0.5 *
# foot_length, y: -0.5 * toe_width} - {x: 0.5 * foot_length, y: 0.5 * toe_width} - {x: -0.5 *
# foot_length, y: -0.5 * heel_width} - {x: -0.5 * foot_length, y: 0.5 * heel_width} 
ihmc_msgs/Point2dRosMessage[] predicted_contact_points

# This contains information on what the swing trajectory should be for each step. Recomended is
# DEFAULT. 
uint8 trajectory_type

# In case the trajectory type is set to custom the swing waypoints can be specified here (As of Dec
# 2016 only two waypoints are supported). The waypoints specify the sole position in the world frame.
geometry_msgs/Vector3[] trajectory_waypoints

# Contains information on how high the robot should step. This affects trajectory types default and
# obstacle clearance.Recommended values are between 0.1 (minimum swing height, default) and 0.25. 
float64 swing_height

# Boolean that determines whether the controller should use swing and transfer times specifies in this
# message (if true) orif the default swing and transfer times from the FootstepDataListMessage should
# be used (if false).
bool has_timings

# Specifies the swing time for this footstep.
float64 swing_time

# Specifies the transfer time before this step.
float64 transfer_time

# Boolean that determines whether the controller should attemp at keeping absolute timings for the
# execution of this footstep. This means that a time for foot lift-off (end of toe off) needs to be
# specified. The timing is set with respect to the start of the execution of the FootstepDataList that
# this footstep is part of.
bool has_absolute_time

# If using absolute timings this is the time at which the controller will start the swing. The time is
# with respect to the time at which the controller recieves the walking command. The value of this
# time must be increasing throughout a FootstepDataListMessage, otherwise it is ignored.
float64 swing_start_time

# A unique id for the current message. This can be a timestamp or sequence number. Only the unique id
# in the top level message is used, the unique id in nested messages is ignored. Use
# /output/last_received_message for feedback about when the last message was received. A message with
# a unique id equals to 0 will be interpreted as invalid and will not be processed by the controller.
int64 unique_id


# This message utilizes "enums". Enum value information for this message follows.

# "robot_side" enum values:
uint8 LEFT=0 # refers to the LEFT side of a robot
uint8 RIGHT=1 # refers to the RIGHT side of a robot

# "footstep_origin" enum values:
uint8 AT_ANKLE_FRAME=0 # The location of the footstep refers to the location of the ankle frame. The ankle frame is fixed in the foot, centered at the last ankle joint. The orientation = [qx = 0.0, qy = 0.0, qz = 0.0, qs = 1.0] corresponds to: x-axis pointing forward, y-axis pointing left, z-axis pointing upward. This option is for backward compatibility only and will be gone in an upcoming release. This origin is deprecated as it directly depends on the robot structure and is not directly related to the actual foot sole.
uint8 AT_SOLE_FRAME=1 # The location of the footstep refers to the location of the sole frame. The sole frame is fixed in the foot, centered at the center of the sole. The orientation = [qx = 0.0, qy = 0.0, qz = 0.0, qs = 1.0] corresponds to: x-axis pointing forward, y-axis pointing left, z-axis pointing upward. This origin is preferred as it directly depends on the actual foot sole and is less dependent on the robot structure.

# "trajectory_type" enum values:
uint8 DEFAULT=0 # is a default trajectory
uint8 OBSTACLE_CLEARANCE=1 # will attempt to step over an obstacle
uint8 CUSTOM=2 # allows to specify trajectory waypoints


================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: ihmc_msgs/Point2dRosMessage
## Point2dRosMessage
# This message represents a point on a 2d plane. The coordinates are referred to as "x" and "y"
# The first coordinate of the point in a 2D plane
float64 x

# The second coordinate of the point in a 2D plane
float64 y

"""
  # Pseudo-constants
  LEFT = 0
  RIGHT = 1
  AT_ANKLE_FRAME = 0
  AT_SOLE_FRAME = 1
  DEFAULT = 0
  OBSTACLE_CLEARANCE = 1
  CUSTOM = 2

  __slots__ = ['origin','robot_side','location','orientation','predicted_contact_points','trajectory_type','trajectory_waypoints','swing_height','has_timings','swing_time','transfer_time','has_absolute_time','swing_start_time','unique_id']
  _slot_types = ['uint8','uint8','geometry_msgs/Vector3','geometry_msgs/Quaternion','ihmc_msgs/Point2dRosMessage[]','uint8','geometry_msgs/Vector3[]','float64','bool','float64','float64','bool','float64','int64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       origin,robot_side,location,orientation,predicted_contact_points,trajectory_type,trajectory_waypoints,swing_height,has_timings,swing_time,transfer_time,has_absolute_time,swing_start_time,unique_id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FootstepDataRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.origin is None:
        self.origin = 0
      if self.robot_side is None:
        self.robot_side = 0
      if self.location is None:
        self.location = geometry_msgs.msg.Vector3()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.predicted_contact_points is None:
        self.predicted_contact_points = []
      if self.trajectory_type is None:
        self.trajectory_type = 0
      if self.trajectory_waypoints is None:
        self.trajectory_waypoints = []
      if self.swing_height is None:
        self.swing_height = 0.
      if self.has_timings is None:
        self.has_timings = False
      if self.swing_time is None:
        self.swing_time = 0.
      if self.transfer_time is None:
        self.transfer_time = 0.
      if self.has_absolute_time is None:
        self.has_absolute_time = False
      if self.swing_start_time is None:
        self.swing_start_time = 0.
      if self.unique_id is None:
        self.unique_id = 0
    else:
      self.origin = 0
      self.robot_side = 0
      self.location = geometry_msgs.msg.Vector3()
      self.orientation = geometry_msgs.msg.Quaternion()
      self.predicted_contact_points = []
      self.trajectory_type = 0
      self.trajectory_waypoints = []
      self.swing_height = 0.
      self.has_timings = False
      self.swing_time = 0.
      self.transfer_time = 0.
      self.has_absolute_time = False
      self.swing_start_time = 0.
      self.unique_id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2B7d.pack(_x.origin, _x.robot_side, _x.location.x, _x.location.y, _x.location.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w))
      length = len(self.predicted_contact_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.predicted_contact_points:
        _x = val1
        buff.write(_struct_2d.pack(_x.x, _x.y))
      buff.write(_struct_B.pack(self.trajectory_type))
      length = len(self.trajectory_waypoints)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_waypoints:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_dB2dBdq.pack(_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.location is None:
        self.location = geometry_msgs.msg.Vector3()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.predicted_contact_points is None:
        self.predicted_contact_points = None
      if self.trajectory_waypoints is None:
        self.trajectory_waypoints = None
      end = 0
      _x = self
      start = end
      end += 58
      (_x.origin, _x.robot_side, _x.location.x, _x.location.y, _x.location.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w,) = _struct_2B7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.predicted_contact_points = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.Point2dRosMessage()
        _x = val1
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.predicted_contact_points.append(val1)
      start = end
      end += 1
      (self.trajectory_type,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_waypoints = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.trajectory_waypoints.append(val1)
      _x = self
      start = end
      end += 42
      (_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id,) = _struct_dB2dBdq.unpack(str[start:end])
      self.has_timings = bool(self.has_timings)
      self.has_absolute_time = bool(self.has_absolute_time)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2B7d.pack(_x.origin, _x.robot_side, _x.location.x, _x.location.y, _x.location.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w))
      length = len(self.predicted_contact_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.predicted_contact_points:
        _x = val1
        buff.write(_struct_2d.pack(_x.x, _x.y))
      buff.write(_struct_B.pack(self.trajectory_type))
      length = len(self.trajectory_waypoints)
      buff.write(_struct_I.pack(length))
      for val1 in self.trajectory_waypoints:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_dB2dBdq.pack(_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.location is None:
        self.location = geometry_msgs.msg.Vector3()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.predicted_contact_points is None:
        self.predicted_contact_points = None
      if self.trajectory_waypoints is None:
        self.trajectory_waypoints = None
      end = 0
      _x = self
      start = end
      end += 58
      (_x.origin, _x.robot_side, _x.location.x, _x.location.y, _x.location.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation.w,) = _struct_2B7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.predicted_contact_points = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.Point2dRosMessage()
        _x = val1
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.predicted_contact_points.append(val1)
      start = end
      end += 1
      (self.trajectory_type,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.trajectory_waypoints = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Vector3()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.trajectory_waypoints.append(val1)
      _x = self
      start = end
      end += 42
      (_x.swing_height, _x.has_timings, _x.swing_time, _x.transfer_time, _x.has_absolute_time, _x.swing_start_time, _x.unique_id,) = _struct_dB2dBdq.unpack(str[start:end])
      self.has_timings = bool(self.has_timings)
      self.has_absolute_time = bool(self.has_absolute_time)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_2B7d = struct.Struct("<2B7d")
_struct_B = struct.Struct("<B")
_struct_dB2dBdq = struct.Struct("<dB2dBdq")
_struct_3d = struct.Struct("<3d")
