# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ihmc_msgs/SupportPolygonRosMessage.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ihmc_msgs.msg

class SupportPolygonRosMessage(genpy.Message):
  _md5sum = "214687cf8edfa8626dde4b3a7d93f2fe"
  _type = "ihmc_msgs/SupportPolygonRosMessage"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## SupportPolygonRosMessage
# This message contains of an array of points that represent the convex hull of a support polygon for
# a single robot foot
# Constant defining max number of possible elements in the array of points
int32 MAXIMUM_NUMBER_OF_VERTICES=8

# The number of vertices in the array of points
int32 number_of_vertices

# The vertices of the support polygon
ihmc_msgs/Point2dRosMessage[] vertices


================================================================================
MSG: ihmc_msgs/Point2dRosMessage
## Point2dRosMessage
# This message represents a point on a 2d plane. The coordinates are referred to as "x" and "y"
# The first coordinate of the point in a 2D plane
float64 x

# The second coordinate of the point in a 2D plane
float64 y

"""
  # Pseudo-constants
  MAXIMUM_NUMBER_OF_VERTICES = 8

  __slots__ = ['number_of_vertices','vertices']
  _slot_types = ['int32','ihmc_msgs/Point2dRosMessage[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       number_of_vertices,vertices

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SupportPolygonRosMessage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.number_of_vertices is None:
        self.number_of_vertices = 0
      if self.vertices is None:
        self.vertices = []
    else:
      self.number_of_vertices = 0
      self.vertices = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_i.pack(self.number_of_vertices))
      length = len(self.vertices)
      buff.write(_struct_I.pack(length))
      for val1 in self.vertices:
        _x = val1
        buff.write(_struct_2d.pack(_x.x, _x.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.vertices is None:
        self.vertices = None
      end = 0
      start = end
      end += 4
      (self.number_of_vertices,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.vertices = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.Point2dRosMessage()
        _x = val1
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.vertices.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_i.pack(self.number_of_vertices))
      length = len(self.vertices)
      buff.write(_struct_I.pack(length))
      for val1 in self.vertices:
        _x = val1
        buff.write(_struct_2d.pack(_x.x, _x.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.vertices is None:
        self.vertices = None
      end = 0
      start = end
      end += 4
      (self.number_of_vertices,) = _struct_i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.vertices = []
      for i in range(0, length):
        val1 = ihmc_msgs.msg.Point2dRosMessage()
        _x = val1
        start = end
        end += 16
        (_x.x, _x.y,) = _struct_2d.unpack(str[start:end])
        self.vertices.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_i = struct.Struct("<i")
_struct_2d = struct.Struct("<2d")
